unit isapiext;

// TTomIsapiExt Ver 1.00
// Freeware Unit (NOV 5 1996) , Help You Write A 32 Bit ISAPI Extension DLL
// Written By Tom Lee
// Taiwan , Republic Of China
// E-Mail Address: Tomm.bbs@csie.nctu.edu.tw
// Home Page: http://www.aaa.hinet.net/delphi
// (Chinese BIG-5 Encode Home Page)
//
// History
// Ver 1.0   This Release
//
// Note:
// TTomIsapiExt Class don't handle with ECB.lpbData over 48K situation.

interface

uses Windows, Classes, SysUtils, ISAPI , Dialogs;

const
     DefaultBufferSize=4096;

type
TTomIsapiExt = class (TObject)
private
    {Private Part Declare}
    FInputRawData:String;
    FECB: ^TEXTENSION_CONTROL_BLOCK ;
    function ParamCount:Integer;
    function GetToken(aString, SepChar: String; TokenNum: integer):String;
    function NumToken(aString, SepChar: String):integer;
    function GetParamItemValue(inpStr:string;Cnt:integer):string;
    function GetParamItemName(inpStr:string;Cnt:integer):string;
public
    {Public Part Declare}
    ContentLength:integer;
    ContentType:string;
    GatewayInterface:string;
    HttpAccept:string;
    HttpUserAgent:string;
    Params:TStrings;
    QueryString:string;
    RemoteAddr:string;
    RemoteHost:string;
    RemoteUser:string;
    RequestMethod:string;
    ScriptName:string;
    ServerName:string;
    ServerProtocol:string;
    ServerSoftware:string;
    constructor Create( var AECB: TEXTENSION_CONTROL_BLOCK );
    destructor destroy ; override ;
    function ParamRawData:string;
    procedure Write(Buffer:string);
end;


implementation

constructor TTomIsapiExt.Create( var AECB: TEXTENSION_CONTROL_BLOCK );
var
   buf:PChar;
   bufsize:DWORD;
   ContentLengthStr:string;
   idx:integer;
   ret:LongBool;
begin
    inherited Create;
    FECB := @AECB ;
    Params:=TStringList.Create;

    // Get Server Variable
    RequestMethod:=StrPas(FECB.lpszMethod);

    try
       bufsize:=DefaultBufferSize;
       GetMem(Buf,bufsize);
       ret:=FECB.GetServerVariable( FECB.ConnID,'CONTENT_LENGTH',Buf,bufsize);
       try
          ContentLength:=StrToInt(StrPas(Buf));
       except
             ContentLength:=0;
       end;
    finally
           freeMem(Buf);
    end;

    try
       bufsize:=DefaultBufferSize;
       GetMem(Buf,bufsize);
       ret:=FECB.GetServerVariable( FECB.ConnID,'SERVER_SOFTWARE',Buf,bufsize);
       ServerSoftware:=StrPas(Buf);
    finally
           Freemem(Buf);
    end;

    try
       bufsize:=DefaultBufferSize;
       GetMem(Buf,bufsize);
       ret:=FECB.GetServerVariable( FECB.ConnID,'SERVER_NAME',Buf,bufsize);
       ServerName:=StrPas(Buf);
    finally
           Freemem(Buf);
    end;

    try
       bufsize:=DefaultBufferSize;
       GetMem(Buf,bufsize);
       ret:=FECB.GetServerVariable( FECB.ConnID,'GATEWAY_INTERFACE',Buf,bufsize);
       GatewayInterface:=StrPas(Buf);
    finally
           Freemem(Buf);
    end;

    try
       bufsize:=DefaultBufferSize;
       GetMem(Buf,bufsize);
       ret:=FECB.GetServerVariable( FECB.ConnID,'SERVER_PROTOCOL',Buf,bufsize);
       ServerProtocol:=StrPas(Buf);
    finally
           Freemem(Buf);
    end;

    try
       bufsize:=DefaultBufferSize;
       GetMem(Buf,bufsize);
       ret:=FECB.GetServerVariable( FECB.ConnID,'HTTP_ACCEPT',Buf,bufsize);
       HttpAccept:=StrPas(Buf);
    finally
           Freemem(Buf);
    end;

    try
       bufsize:=DefaultBufferSize;
       GetMem(Buf,bufsize);
       ret:=FECB.GetServerVariable( FECB.ConnID,'SCRIPT_NAME',Buf,bufsize);
       ScriptName:=StrPas(Buf);
    finally
           Freemem(Buf);
    end;

    try
       bufsize:=DefaultBufferSize;
       GetMem(Buf,bufsize);
       ret:=FECB.GetServerVariable( FECB.ConnID,'REMOTE_ADDR',Buf,bufsize);
       RemoteAddr:=StrPas(Buf);
    finally
           Freemem(Buf);
    end;

    try
       bufsize:=DefaultBufferSize;
       GetMem(Buf,bufsize);
       ret:=FECB.GetServerVariable( FECB.ConnID,'REMOTE_HOST',Buf,bufsize);
       RemoteHost:=StrPas(Buf);
    finally
           Freemem(Buf);
    end;

    try
       bufsize:=DefaultBufferSize;
       GetMem(Buf,bufsize);
       ret:=FECB.GetServerVariable( FECB.ConnID,'REMOTE_USER',Buf,bufsize);
       RemoteUser:=StrPas(Buf);
    finally
           Freemem(Buf);
    end;

    try
       bufsize:=DefaultBufferSize;
       GetMem(Buf,bufsize);
       ret:=FECB.GetServerVariable( FECB.ConnID,'CONTENT_TYPE',Buf,bufsize);
       ContentType:=StrPas(Buf);
    finally
           Freemem(Buf);
    end;

    QueryString:=StrPas(FECB.lpszQueryString);
    if Uppercase(RequestMethod)='POST' then
         FInputRawData:=StrPas(FECB.LpbData)
    else
        // Get Request Method
        FInputRawData:=QueryString;

    for idx:= 1 to ParamCount do
        Params.Add(GetParamItemName(FInputRawData,idx)+'='+GetParamItemValue(FInputRawData,idx));

end;

destructor TTomIsapiExt.destroy;
begin
     Params.Free;
     inherited Destroy;
end;


function TTomIsapiExt.GetToken(aString, SepChar: String; TokenNum: integer):String;
var
   Token     : String;
   StrLen    : integer;
   TNum      : integer;
   TEnd      : integer;

begin
     StrLen := Length(aString);
     TNum   := 1;
     TEnd   := StrLen;
     while ((TNum <= TokenNum) and (TEnd <> 0)) do
     begin
          TEnd := Pos(SepChar,aString);
          if TEnd <> 0 then
          begin
               Token := Copy(aString,1,TEnd-1);
               Delete(aString,1,TEnd);
               Inc(TNum);
          end
          else
          begin
               Token := aString;
          end;
     end;
     if TNum >= TokenNum then
     begin
          GetToken := Token;
     end
     else
     begin
          GetToken := '';
     end;
end;

function TTomIsapiExt.NumToken(aString, SepChar: String):integer;
{
parameters: aString : the complete string
            SepChar : a single character used as separator
                      between the substrings
result    : the number of substrings
}

var
   RChar     : Char;
   StrLen    : integer;
   TNum      : integer;
   TEnd      : integer;

begin
     if SepChar = '#' then
     begin
          RChar := '*'
     end
     else
     begin
         RChar := '#'
     end;
     StrLen := Length(aString);
     TNum   := 0;
     TEnd   := StrLen;
     while TEnd <> 0 do
     begin
          Inc(TNum);
          TEnd := Pos(SepChar,aString);
          if TEnd <> 0 then
          begin
               aString[TEnd] := RChar;
          end;
     end;
     NumToken := TNum;
end;

function TTomIsapiExt.GetParamItemName(inpStr:string;Cnt:integer):string;
var
   tmpStr:string;
begin
     tmpStr:= GetToken(inpStr,'&',Cnt);
     result:=GetToken(tmpStr,'=',1);
end;

function TTomIsapiExt.GetParamItemValue(inpStr:string;Cnt:integer):string;
var
   idx:integer;
   tmpStr,OutStr:string;
begin
     tmpStr:= GetToken(inpStr,'&',Cnt);
     tmpStr:= GetToken(tmpStr,'=',2);
     idx:=1;
     while (idx<=length(tmpStr)) do
     begin
          if tmpStr[idx]='%' then
           begin
               OutStr:=OutStr+ chr(StrToint('$'+Copy(tmpStr,idx+1,2)));
               inc(idx,3);
           end
          else
           begin
              if tmpStr[idx]='+' then
                OutStr:=OutStr+chr(32)
               else
                OutStr:=OutStr+tmpStr[idx];
              inc(idx);
           end
     end;
     result:=OutStr;
end;

function TTomIsapiExt.ParamCount:Integer;
begin
     Result:=NumToken(FInputRawData,'&');
end;

function TTomIsapiExt.ParamRawData:string;
begin
    Result:=FInputRawData;
end;

procedure TTomIsapiExt.Write(Buffer:string);
var
   Leng:integer;
begin
     leng:=Length(Buffer);
     FECB.WriteClient (FECB.ConnID,PChar(Buffer),Leng,0) ;
end ;

end.
