library tom;

uses
    Windows,SysUtils,Classes,isapi,
    isapiext in 'isapiext.pas';

const
     crlf=^M^J;

function GetExtensionVersion( var Ver: THSE_VERSION_INFO ): BOOL ; stdcall ; export ;
begin
  Result := True ;
  try
    Ver.dwExtensionVersion := MAKELONG ( HSE_VERSION_MINOR, HSE_VERSION_MAJOR ) ;
    Ver.lpszExtensionDesc := 'Tom Test ISAPI Extension DLL';
  except
    Result := False ;
  end ;
end ;

{ Generic implementation of ISAPIExtensionProc }

function HttpExtensionProc( var ECB: TEXTENSION_CONTROL_BLOCK ): DWORD; stdcall ; export ;
var
   idx:integer;
   IsapiObject: TTomIsapiExt ;
   ParameterValue,ParameterName:string;
begin
     try
        try
           IsapiObject := TTomIsapiExt.Create ( ECB ) ;
           IsapiObject.write('<HTML><HEAD><TITLE>ISAPI Application Reply</TITLE></HEAD>' + CrLf);
           IsapiObject.write('<BODY BACKGROUND="/BACK.GIF">' + CrLf);
           IsapiObject.write('<CENTER><H1>ISAPI Extension Program Reply</H1></CENTER>' + CrLf);
           IsapiObject.write('<P>Parameter Number:'+IntToStr(IsapiObject.Params.Count)+ CrLf);
           IsapiObject.write('<HR>'+ CrLf);
           for idx:= 1 to IsapiObject.Params.Count do
           begin
                IsapiObject.write('<P>Parameter No. ('+IntToStr(idx-1)+'):'+ CrLf);
                ParameterName:=IsapiObject.Params.Names[idx-1];
                IsapiObject.write('<P>Parameter Name:'+ParameterName+CrLf);
                ParameterValue:=IsapiObject.Params.values[ParameterName];
                IsapiObject.write('<P>Parameter Value:'+ParameterValue+ CrLf);
                IsapiObject.write('<HR>'+ CrLf);
           end;
           IsapiObject.write('<p>WWW Browser IP address is : ' + IsapiObject.RemoteAddr+ CrLf);
           IsapiObject.write('</BODY>' + CrLf);
           IsapiObject.write('</HTML>' + CrLf);
        finally
           IsapiObject.Free ;
        end ;

        Result := HSE_STATUS_SUCCESS ;
  except
    Result := HSE_STATUS_ERROR ;
  end ;
end ;

{ Export the two ISAPI routines from the library }

exports
       GetExtensionVersion,
       HttpExtensionProc ;

begin
end.

